#include "bg.h"
#include "res.h"

//---------------------------------------------------------------------------
ST_BG Bg[BG_MAX_CNT];


//---------------------------------------------------------------------------
EWRAM_CODE void BgInit()
{
	const u16 mapBase[]  = { 26, 27, 28, 29 };
	const u16 tileBase[] = {  0,  0,  1,  1 };
	s32 i;

	for(i=0; i<BG_MAX_CNT; i++)
	{
		Bg[i].mapBase     = MAP_BASE(mapBase[i]);
		Bg[i].mapBaseAdr  = MAP_BASE_ADR(mapBase[i]);
		Bg[i].tileBase    = TILE_BASE(tileBase[i]);
		Bg[i].tileBaseAdr = TILE_BASE_ADR(tileBase[i]); 
	}

	for(i=0; i<32*32; i++)
	{
		Bg[0].mapBaseAdr[i] = 0;
		Bg[1].mapBaseAdr[i] = 0;
		Bg[2].mapBaseAdr[i] = 0;
		Bg[3].mapBaseAdr[i] = 0;
	}

	for(i=0; i<0x2000; i++)
	{
		Bg[0].tileBaseAdr[i] = 0;
//		Bg[1].tileBaseAdr[i] = 0;
//		Bg[2].tileBaseAdr[i] = 0;
//		Bg[3].tileBaseAdr[i] = 0;
	}

	//^C̐ݒ
	for(i=0; i<4096; i++)
	{
		Bg[0].tileBaseAdr[i] = ascii_chr[i];
	}

	//F̐ݒ
	for(i=0; i<16*16; i++)
	{
		BG_PALETTE[i] = bgpal[i];
		SPRITE_PALETTE[i] = sppal[i];
	}

	//n[hEFA̐ݒ
	REG_DISPCNT = (MODE_0 | OBJ_1D_MAP | BG0_ON | OBJ_ON);
	REG_BG0CNT  = (BG_SIZE_0 | BG_16_COLOR | Bg[0].tileBase | Bg[0].mapBase | 0);
	REG_BG1CNT  = (BG_SIZE_0 | BG_16_COLOR | Bg[1].tileBase | Bg[1].mapBase | 0);
	REG_BG2CNT  = (BG_SIZE_0 | BG_16_COLOR | Bg[2].tileBase | Bg[2].mapBase | 2 | BG_WRAP);
	REG_BG3CNT  = (BG_SIZE_0 | BG_16_COLOR | Bg[3].tileBase | Bg[3].mapBase | 3 | BG_WRAP);
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bg1On()
{
	REG_DISPCNT |= BG1_ON;
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bg1Off()
{
	REG_DISPCNT &= ~BG1_ON;
}
//---------------------------------------------------------------------------
EWRAM_CODE void BgPrint(u16 no, u16 x, u16 y, char* s)
{
	u16* map = &Bg[no].mapBaseAdr[x + y * 32];

	while(*s != NULL)
	{
		*map++ = *s++ - ' ';
	}
}
