#include "dmachain_arm.h"


//---------------------------------------------------------------------------
ST_DMA_CHAIN DmaChain[MAX_DMA_CHAIN_CNT];
u16 DmaChainNum;
u16 DmaChainExec;


//---------------------------------------------------------------------------
EWRAM_CODE void DmaChainInit()
{
	DmaChainNum  = 0;
	DmaChainExec = 0;
}
//---------------------------------------------------------------------------
IWRAM_CODE void DmaChainEnqueue(u32* src, u32* dst, u16 size)
{
	DmaChain[DmaChainNum].src  = src;
	DmaChain[DmaChainNum].dst  = dst;
	DmaChain[DmaChainNum].mode = size | (DMA_SRC_INC | DMA_DST_INC | DMA16 | DMA_ENABLE);
	DmaChainNum++;

	DmaChainNum &= (MAX_DMA_CHAIN_CNT - 1);
}
//---------------------------------------------------------------------------
IWRAM_CODE void DmaChainEnqueueFix(u32* src, u32* dst, u16 size)
{
	DmaChain[DmaChainNum].src  = src;
	DmaChain[DmaChainNum].dst  = dst;
	DmaChain[DmaChainNum].mode = size | (DMA_SRC_FIXED | DMA_DST_INC | DMA16 | DMA_ENABLE);
	DmaChainNum++;

	DmaChainNum &= (MAX_DMA_CHAIN_CNT - 1);
}
//---------------------------------------------------------------------------
IWRAM_CODE void DmaChainTransfer()
{
	while(DmaChain[DmaChainExec].mode != 0)
	{
		//while (REG_DMA3CNT & DMA_ENABLE) {}
		REG_DMA3SAD = (u32)DmaChain[DmaChainExec].src;
		REG_DMA3DAD = (u32)DmaChain[DmaChainExec].dst;
		REG_DMA3CNT = (u32)DmaChain[DmaChainExec].mode;
		DmaChain[DmaChainExec].mode = 0;
		DmaChainExec++;

		DmaChainExec &= (MAX_DMA_CHAIN_CNT - 1);
	}
}
