#ifndef __ISR_ARM_H__
#define __ISR_ARM_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "lib/gba.h"

//---------------------------------------------------------------------------
typedef struct {
	void* handler[MAX_INTS];
} ST_INTR_TABLE;


//---------------------------------------------------------------------------
IWRAM_CODE void IntrDummy();
IWRAM_CODE void IntrMain();

EWRAM_CODE void IntrInit();
EWRAM_CODE void IntrStart();
EWRAM_CODE void IntrStop();

EWRAM_CODE void IntrSetHandler(irqMASK num, void* function);
EWRAM_CODE void IntrUnSetHandler(irqMASK num);

EWRAM_CODE void IntrSetMaskEnable(irqMASK mask);
EWRAM_CODE void IntrSetMaskDisable(irqMASK mask);



#ifdef __cplusplus
}
#endif
#endif
