#ifndef __STD_H__
#define __STD_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "gba.h"


//---------------------------------------------------------------------------
typedef char* va_list;

#define _Toupper(c)				((c >= 'a' && c <= 'z') ? c - ('a' - 'A') : c)
#define _IsDigit(c)				((c >= '0') && (c <= '9') ? TRUE : FALSE)
#define _IsAlpha(c)				((c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z') ? TRUE : FALSE)
#define _IsSpace(c)				((c == ' ') ? TRUE : FALSE)

//---------------------------------------------------------------------------
EWRAM_CODE u16   _Strlen(char* s1);
EWRAM_CODE char* _Strncpy(char* ret, char* s2, u16 size);
EWRAM_CODE char* _Strcat(char* ret, char* s2);
EWRAM_CODE s16   _Strcmp(char* s1, char* s2);
EWRAM_CODE s16   _Strncmp(char* s1, char* s2, u16 size);
EWRAM_CODE char* _Strchr(char* str, char chr);
EWRAM_CODE u16   _Atoi(char* s);

EWRAM_CODE char* _Strchr(char* str, char chr);
EWRAM_CODE char* _Memcpy(void* s1, void* s2, u32 size);
EWRAM_CODE s16   _Memcmp(void* s1, void* s2, u32 size);
EWRAM_CODE char* _Memset(void* s, u8 c, u32 size);


IWRAM_CODE void  _Printf(char* format, ...);
IWRAM_CODE char* _Sprintf(char* buf, char* format, ...);
IWRAM_CODE void  _DoSprintf(char* str, char* fmt, va_list ap);
IWRAM_CODE char* _SprintfNum(s32 val, s32 base, char* s);
IWRAM_CODE char* _SprintfNumCol(s32 val, s32 base, char* s, s32 col, bool isTop);


#ifdef __cplusplus
}
#endif
#endif

