#ifndef __VBA_H__
#define __VBA_H__
#ifdef __cplusplus
extern "C" {
#endif
#include "gba_types.h"

/**
 * Records a call graph entry. R12 should contain LR of previous caller.
 */
EWRAM_CODE void mcount();
/**
 * Starts profiling on the given address range (low ... high)
 */
EWRAM_CODE void monstartup(u32 low, u32 high);
/**
 * Controls profiling.
 *
 * mode = 0 stops profiling, mode != 0 starts it
 */
EWRAM_CODE void moncontrol(int mode);
/**
 * Clean up and stop profiling. gmon.out will be written
 */
EWRAM_CODE void moncleanup();
/**
 * Logs a message message to VBA console (or GDB console if using GDB).
 */
EWRAM_CODE void vbalog(const char *msg);

#ifdef __cplusplus
}
#endif
#endif
