#include "std.h"
#include "mymem.h"


//---------------------------------------------------------------------------
ST_MYMEM MyMem EWRAM_BSS;


//---------------------------------------------------------------------------
EWRAM_CODE void MyMemInit()
{
	_Memset((u8*)&MyMem, 0x00, sizeof(ST_MYMEM));
	MyMemFree((u32)&MyMem.ram[0], MYMEM_SIZE);
}
//---------------------------------------------------------------------------
EWRAM_CODE u32 MyMemGetFreeSize()
{
	ST_MYMEM* p = &MyMem;

	u32 freeSize = 0;
	u16 i;

	for(i=0; i<p->cnt; i++)
	{
		freeSize += p->info[i].size;
	}

	return freeSize;
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MyMemFree(u32 addr, u32 size)
{
	ST_MYMEM* p = &MyMem;
	u16 i, j;

	//u32PʂŐ؂蕪܂
	size += 3;
	size &= 0xfffffffc;

//	TRACEOUT("MemFree addr=0x%x size=%d\n", addr, size);

	//free[]addrɕׁׂAfree[]̑}ꏊ߂܂
	for(i=0; i<p->cnt; i++)
	{
		if(p->info[i].addr > addr)
		{
			break;
		}
	}

	//Ő󂫗̈悪邩`FbN܂
	if( (i > 0) && (p->info[i-1].addr + p->info[i-1].size == addr) )
	{
		p->info[i-1].size += size;

		//̋󂫗̈悪邩`FbN܂
		if( (i < p->cnt) && (addr + size == p->info[i].addr) )
		{
			p->info[i-1].size += p->info[i].size;
			p->cnt--;

			//free[i]ȂȂ̂őO֋l߂܂
			while(i < p->cnt)
			{
				p->info[i] = p->info[i + 1];
				i++;
			}
		}

		return TRUE;
	}

	//Ő󂫗̈Ƃ܂Ƃ߂ȂꍇA낪邩`FbN܂
	if( (i < p->cnt) && (addr + size == p->info[i].addr) )
	{
		p->info[i].addr  = addr;
		p->info[i].size += size;

		return TRUE;
	}


	//Oɂ̗̈ɂ܂Ƃ߂ȂꍇAfree[i]ɂ炵ČԂ܂
	if(p->cnt < MYMEM_MAX_INFO_CNT)
	{
		for(j=p->cnt; j>i; j--)
		{
			p->info[j] = p->info[j-1];
		}
		p->cnt++;

		p->info[i].addr = addr;
		p->info[i].size = size;

		return TRUE;
	}

	TRACEOUT("MemFree Error\n");
	return FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8* MyMemAlloc(u32 size)
{
	ST_MYMEM* p = &MyMem;
	u8* addr;
	u16 i;

	size += 3;
	size &= 0xfffffffc;

	for(i=0; i<p->cnt; i++)
	{
		if(p->info[i].size >= size)
		{
			addr = (u8*)p->info[i].addr;

			p->info[i].addr += size;
			p->info[i].size -= size;

			if(p->info[i].size == 0)
			{
				p->cnt--;

				//free[i]ȂȂ̂őO֋l߂܂
				while(i < p->cnt)
				{
					p->info[i] = p->info[i + 1];
					i++;
				}
			}

//			TRACEOUT("MemAlloc addr=0x%x size=%d\n", addr, size);
			return addr;
		}
	}

	TRACEOUT("MemAlloc Error\n");
	return NULL;
}
