#include "std.h"
#include "dmachain_arm.h"
#include "pcg.h"


//---------------------------------------------------------------------------
ST_PCG Pcg;
u32    PcgDummy;


//---------------------------------------------------------------------------
EWRAM_CODE void PcgInit()
{
	_Memset(&Pcg, 0x00, sizeof(ST_PCG));
	Pcg.blkLastChkNum = 1;

	PcgDummy = 0;
}
//---------------------------------------------------------------------------
IWRAM_CODE void PcgClean()
{
	DmaChainEnqueueFix((u32*)&PcgDummy, (u32*)&Pcg.blkCnt[0], MAX_BLOCK_CNT);
}
//---------------------------------------------------------------------------
IWRAM_CODE void PcgSetTileData(void* pDat)
{
	Pcg.pTile = (ST_TILE_BLOCK*)pDat;
}
//---------------------------------------------------------------------------
IWRAM_CODE u16 PcgGetOamTile(u16 pat)
{
	u16 blk = Pcg.patTbl[pat];

	// LbṼ`FbN܂
	if(blk == 0 || (pat != Pcg.blkPat[blk]))
	{
		//ȂꍇAo^pubNƃ^Cf[^̓]s܂
		blk = PcgGetBlockNum();
		PcgSetOamData(pat, blk);
	}
	else
	{
		// o^CNg܂
		Pcg.blkCnt[blk]++;
	}

	return blk * 4;
}
//---------------------------------------------------------------------------
IWRAM_CODE u16 PcgGetBlockNum()
{
	u16 num = Pcg.blkLastChkNum + 1;
	u16 tmp = num;

	// next-fit
	while(num < MAX_BLOCK_CNT)
	{
		if(Pcg.blkCnt[num] == 0)
		{
			goto fit;
		}
		num++;
	}

	// first-fit
	num = 1;
	while(num < tmp)
	{
		if(Pcg.blkCnt[num] == 0)
		{
			goto fit;
		}
		num++;
	}

	// 󂫃ubNȂ
	return 0;

fit:
	Pcg.blkLastChkNum = num;
	return num;
}
//---------------------------------------------------------------------------
IWRAM_CODE void PcgSetOamData(u16 pat, u16 blk)
{
	if(blk == 0)
	{
		return;
	}

	ST_TILE_BLOCK* oam = (ST_TILE_BLOCK*)OBJ_BASE_ADR;
	DmaChainEnqueue((u32*)&Pcg.pTile[pat].tile[0], (u32*)&oam[blk].tile[0], 4 * 16);

	Pcg.blkCnt[blk] = 1;
	Pcg.blkPat[blk] = pat;
	Pcg.patTbl[pat] = blk;
}
