#ifndef __PCG_H__
#define __PCG_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "lib/gba.h"

//---------------------------------------------------------------------------
#define MAX_BLOCK_CNT			256
#define MAX_PATTERN_CNT			1024		//ŏ̃XvCg:1024


//---------------------------------------------------------------------------
typedef struct {
	u16 tile[8*8];
} __PACKED ST_TILE_BLOCK;


typedef struct {
	u16 blkLastChkNum;
	u16 blkCnt[MAX_BLOCK_CNT];
	u16 blkPat[MAX_BLOCK_CNT];
	u16 patTbl[MAX_PATTERN_CNT];

	ST_TILE_BLOCK* pTile;
} ST_PCG;



//---------------------------------------------------------------------------
EWRAM_CODE void PcgInit();
IWRAM_CODE void PcgClean();
IWRAM_CODE void PcgSetTileData(void* pDat);
IWRAM_CODE u16  PcgGetOamTile(u16 pat);
IWRAM_CODE u16  PcgGetBlockNum();
IWRAM_CODE void PcgSetOamData(u16 pat, u16 blk);


#ifdef __cplusplus
}
#endif
#endif
