#include "lib/std.h"
#include "task.h"

//---------------------------------------------------------------------------
ST_TASK Task[TASK_MAX_CNT] EWRAM_BSS;
ST_TASK_STATUS TaskStatus EWRAM_BSS;

//---------------------------------------------------------------------------
EWRAM_CODE void TaskInit()
{
	_Memset((u8*)&Task,  0x00, sizeof(ST_TASK) * TASK_MAX_CNT);
	_Memset((u8*)&TaskStatus, 0x00, sizeof(ST_TASK_STATUS));
}
//---------------------------------------------------------------------------
IWRAM_CODE ST_TASK* TaskGetFreePointer()
{
	u16 tmp = TaskStatus.taskLastChkNum;
	u16 i;

	//first-fit
	for(i=tmp; i<TASK_MAX_CNT; i++)
	{
		if(Task[i].type == TYPE_NOUSE)
		{
			goto fit;
		}
	}

	//next-fit
	for(i=0; i<tmp; i++)
	{
		if(Task[i].type == TYPE_NOUSE)
		{
			goto fit;
		}
	}

	return NULL;

fit:
	TaskStatus.taskLastChkNum = i;
	TaskStatus.taskCnt++;

	return &Task[i];
}
//---------------------------------------------------------------------------
IWRAM_CODE void TaskSort()
{
	ST_TASK_STATUS* p = &TaskStatus;
	u16 i;

	p->runCnt  = 0;
	p->drawCnt = 0;

	for(i=0; i<TASK_MAX_CNT; i++)
	{
		if(Task[i].type == TYPE_NOUSE)
		{
			continue;
		}

		if(Task[i].isRun == TRUE)
		{
			p->runMap[p->runCnt++] = i;
		}

		if(Task[i].isDraw == TRUE)
		{
			p->drawMap[p->drawCnt++] = i;
		}
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void TaskRun()
{
	ST_TASK_STATUS* p = &TaskStatus;
	u16 num;
	u16 i;

	for(i=0; i<p->runCnt; i++)
	{
		num = p->runMap[i];
		Task[num].pRun(&Task[num]);
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void TaskDraw()
{
	ST_TASK_STATUS* p = &TaskStatus;
	u16 num;
	u16 i;

	for(i=0; i<p->drawCnt; i++)
	{
		num = p->drawMap[i];
		Task[num].pDraw(&Task[num]);
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void TaskMaskRun(u16 type, bool flag)
{
	u16 i;

	for(i=0; i<TASK_MAX_CNT; i++)
	{
		if(Task[i].type == type)
		{
			Task[i].isRun = flag;
		}
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void TaskMaskDraw(u16 type, bool flag)
{
	u16 i;

	for(i=0; i<TASK_MAX_CNT; i++)
	{
		if(Task[i].type == type)
		{
			Task[i].isDraw = flag;
		}
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE u16 TaskGetTypeCnt(u16 type)
{
	u16 cnt = 0;
	u16 i;

	for(i=0; i<TASK_MAX_CNT; i++)
	{
		if(Task[i].type == type)
		{
			cnt++;
		}
	}

	return cnt;
}
