#ifndef __TASK_H__
#define __TASK_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"

//---------------------------------------------------------------------------
#define TASK_MAX_TYPE			256
#define TASK_MAX_CNT			1024


enum TaskType {
	TYPE_NOUSE = 0,
	TYPE_SYSTEM,
	TYPE_SCENE,

	TYPE_MYSHIP,
	TYPE_MYSHOT,
	TYPE_BOMB,

	TYPE_ITEM,

	TYPE_ENEMY,
	TYPE_BULLET,

	TYPE_PARTICLE,

	DEAD_BEEF = 0xdeadbeef,
};

//---------------------------------------------------------------------------
typedef struct {
	u16  type;
	bool isRun;
	bool isDraw;
	void (*pRun)(void* p);
	void (*pDraw)(void* p);
	void* pVal;
} ST_TASK;

typedef struct {
	u16 runCnt;
	u16 runMap[TASK_MAX_CNT];

	u16 drawCnt;
	u16 drawMap[TASK_MAX_CNT];

	u16 taskCnt;
	u16 taskLastChkNum;
} ST_TASK_STATUS;

//---------------------------------------------------------------------------
EWRAM_CODE void TaskInit();
IWRAM_CODE ST_TASK* TaskGetFreePointer();

IWRAM_CODE void TaskSort();
IWRAM_CODE void TaskRun();
IWRAM_CODE void TaskDraw();
IWRAM_CODE void TaskMaskRun(u16 type, bool flag);
IWRAM_CODE void TaskMaskDraw(u16 type, bool flag);

IWRAM_CODE u16  TaskGetTypeCnt(u16 type);



#ifdef __cplusplus
}
#endif
#endif
