#include "main.h"
#include "Key.h"
#include "mymem.h"
#include "spr_arm.h"
#include "res.h"
#include "task.h"
#include "task_myship.h"
#include "task_bullet.h"


//---------------------------------------------------------------------------
//key.c
extern ST_KEY Key;
//main.c
extern ST_STATUS Status;


//---------------------------------------------------------------------------
EWRAM_CODE void TaskMyShipAlloc()
{
	ST_TASK* pT = TaskGetFreePointer();

	if(pT == NULL)
	{
		return;
	}

	ST_TASK_MYSHIP* pM = (ST_TASK_MYSHIP*)MyMemAlloc(sizeof(ST_TASK_MYSHIP));

	pT->type     = TYPE_MYSHIP;
	pT->isRun    = TRUE;
	pT->isDraw   = TRUE;
	pT->pRun     = (void*)&TaskMyShipRun;
	pT->pDraw    = (void*)&TaskMyShipDraw;
	pT->pVal     = (void*)pM;

	pM->shotWait = 0;
	pM->deg      = 0;
	pM->num      = 1;
	pM->x        = INT2FIX(240 / 2);
	pM->y        = INT2FIX(160 / 2);
}
//---------------------------------------------------------------------------
EWRAM_CODE void TaskMyShipRun(void* s)
{
	ST_TASK* t = (ST_TASK*)s;
	ST_TASK_MYSHIP* p = (ST_TASK_MYSHIP*)t->pVal;

	if(Key.trg & KEY_L)
	{
		t->type   = TYPE_NOUSE;
		t->isRun  = FALSE;
		t->isDraw = FALSE;

		MyMemFree((u32)p, sizeof(ST_TASK_MYSHIP));
		return;
	}

	if(Key.trg & KEY_A || Key.cnt & KEY_B)
	{
		p->num++;
		if(p->num >= bullet1_a)
		{
			p->num = 1;
		}
	}

	if(Key.cnt & KEY_UP)    p->y -= INT2FIX(2);
	if(Key.cnt & KEY_DOWN)  p->y += INT2FIX(2);
	if(Key.cnt & KEY_LEFT)  p->x -= INT2FIX(2);
	if(Key.cnt & KEY_RIGHT) p->x += INT2FIX(2);

	p->shotWait++;
	if(p->shotWait > Status.bulletWait)
	{
		p->shotWait = 0;

		p->deg += Status.deg;
		TaskBulletAlloc(p->x, p->y, p->deg, Status.bulletSpeed, Status.bulletChr);
	}

	s16 pal = (p->num < fragment1_a) ? 0 : SP_PAL(15);
	SprSetBuf(p->num, p->x, p->y, pal);
}
//---------------------------------------------------------------------------
EWRAM_CODE void TaskMyShipDraw(void* s)
{

	ST_TASK* t = (ST_TASK*)s;
	ST_TASK_MYSHIP* p = (ST_TASK_MYSHIP*)t->pVal;
}
